-- defaultLayout.lua
local NameOfLayout = "Vertical"
local Description;
local layerFrame


local function Layout(mainFrame, cds)
	-- Update()
	-- CreateCastFrame( spellTexture, RTframe, height, width, relwhich, relto )
	-- createLayout()
	-- deleteLayout()
	
	local MoonTimeEclipseframe
	local MoonTimeMoonfireframe
	local MoonTimeSunfireframe
	local MoonTimeChargesframe
	
	
	local layerFrame = CreateFrame("Frame", "layerFrame", mainFrame )
	layerFrame:SetHeight( mainFrame:GetHeight() )
	layerFrame:SetWidth( mainFrame:GetWidth() )
	layerFrame:SetPoint("CENTER")
	layerFrame:Hide()
	
	layerFrame.Update = function()
		
		local EDir, Epower = cds:GetEclipseDirection()
		local MF = cds:GetMoonfireCD()
		local SunF = cds:GetSunfireCD()
		local charges = cds:GetCharges()
		
		
		if( Epower <= 0 ) then 
			MoonTimeEclipseframe:SetIcon( Lunar_icon )
			local color = "0088ff"
			MoonTimeEclipseframe:SetText( "|cff"..color..abs(Epower).."|r", bool);
		end
		
		if( Epower > 0 ) then 
			MoonTimeEclipseframe:SetIcon( Solar_icon )		
			local color = "ffff00"
			MoonTimeEclipseframe:SetText( "|cff"..color..Epower.."|r", bool);
		end
		
		if MF>10 then
			MoonTimeMoonfireframe:SetText( string.format("|cfff6ffff%2.0f|r", (MF) ) )
			elseif MF>0 then
			MoonTimeMoonfireframe:SetText( string.format("|cfff6ffff%2.1f|r", (MF) ) )
			else
			MoonTimeMoonfireframe:SetText( '' )
		end
		
		if SunF>10 then
			MoonTimeSunfireframe:SetText( string.format("|cfff6ffff%2.0f|r", (SunF) ) )
			elseif SunF>0 then
			MoonTimeSunfireframe:SetText( string.format("|cfff6ffff%2.1f|r", (SunF) ) )
			else
			MoonTimeSunfireframe:SetText( '' )
		end
		
		MoonTimeChargesframe:SetText( '|cfff6ffff' .. charges .. '|r' )
		MoonTimeChargesframe.texture:SetGradientAlpha("HORIZONTAL", 1, 1, 1, 1, 1, 1, 1, 0)
		MoonTimeChargesframe.texture2:SetGradientAlpha("HORIZONTAL", 1, 1, 1, 0, 1, 1, 1, .86)
		
		
	end
	
	layerFrame.CreateCastFrame = function( spellTexture, RTframe, height, width, relwhich, relto )
		local frame = CreateFrame( "Frame", "MTCastframe"..RTframe:GetName(), layerFrame )
		frame:SetHeight(height)
		frame:SetWidth(width)
		frame:SetPoint(relwhich, RTframe, relto, 0, 0)
		frame.texture = frame:CreateTexture("CastFrameTexture")
		frame.texture:SetTexture(spellTexture);
		frame.texture:SetAllPoints()
		
		local labelframe = frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
		labelframe:SetTextColor( 1, 1, 0, 1 );
		
		frame.SetText = function( self, msg )
			
			msg = tostring(msg)
			if( msg == '' ) then
				frame.texture:SetVertexColor(1,1,1,1)		
				else
				frame.texture:SetVertexColor(.3,.3,.3,.7)	
				
				
				msgtext = msg:gsub('|r', '')
				msgtext = msgtext:gsub('|c........', '')
				msgtext = msgtext:gsub('%d', '8')
				
				local h = round(frame:GetHeight()/2)
				labelframe:SetFont("Fonts\\FRIZQT__.TTF", h, "THICKOUTLINE")
				-- labelframe:SetText(msg)
				labelframe:SetText(msgtext)
				
				
				while labelframe:GetStringWidth() > width do
					h = h-1;
					labelframe:SetFont("Fonts\\FRIZQT__.TTF", h, "THICKOUTLINE")
				end
				labelframe:SetPoint("CENTER", frame, "CENTER",2,-floor(h/10+.5))
			end
			
			
			labelframe:SetText(msg)
			
			
			
			
		end
		
		frame.SetIcon = function( self, icon )
			frame.texture:SetTexture(icon)
		end
		
		return frame
	end
	
	layerFrame.createLayout = function ()
		mainFrame:SetHeight(96)
		mainFrame:SetWidth(64)
		local castwidth = 24
		local castheight = 24
		
		MoonTimeEclipseframe = layerFrame.CreateCastFrame( SF_icon, mainFrame, castheight, castwidth, "TOP", "CENTER")
		MoonTimeMoonfireframe = layerFrame.CreateCastFrame( MF_icon, MoonTimeEclipseframe, castheight, castwidth, "TOP", "BOTTOM")
		MoonTimeSunfireframe = layerFrame.CreateCastFrame( SunF_icon, MoonTimeMoonfireframe, castheight, castwidth, "TOP", "BOTTOM")
		MoonTimeChargesframe = layerFrame.CreateCastFrame( SS_icon, MoonTimeSunfireframe, castheight, castwidth, "TOP", "BOTTOM")
		
		MoonTimeChargesframe.texture:SetGradientAlpha("HORIZONTAL", 1, 1, 1, 1, 1, 1, 1, 0)
		
		MoonTimeChargesframe.texture2 = MoonTimeChargesframe:CreateTexture("CastFrameTexture2")
		MoonTimeChargesframe.texture2:SetTexture(SR_icon);
		MoonTimeChargesframe.texture2:SetGradientAlpha("HORIZONTAL", 1, 1, 1, 0, 1, 1, 1, .86)
		MoonTimeChargesframe.texture2:SetAllPoints()
		
	end
	
	
	layerFrame.deleteLayout = function()
		MoonTimeEclipseframe:Hide()
		MoonTimeEclipseframe = nil
		MoonTimeMoonfireframe:Hide()
		MoonTimeMoonfireframe = nil
		MoonTimeSunfireframe:Hide()
		MoonTimeSunfireframe = nil
		MoonTimeChargesframe:Hide()
		MoonTimeChargesframe = nil
		
		
		layerFrame:Hide()
		layerFrame = nil
	end
	
	return layerFrame
end

-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerLayout( name )									-- Beginn initialize
	local LayoutFrame
	local frame = CreateFrame( "Frame", name, UIParent	)
	frame.ID = name
	frame:RegisterEvent("VARIABLES_LOADED");
	frame:SetScript("OnEvent", 
		function( self, event )
			frame:UnregisterAllEvents()
			-- if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
			-- werden die ausstehenden Events registriert
			if ( GetLocale() == "deDE" ) then
				frame.description = MoonTime_Strings["deDE"]["description"]
				else
				frame.description = MoonTime_Strings["enGB"]["description"]
			end
			
			MoonTimeDoorKeeper:RegisterLayout(self);
			-- end
		end
	)
	
	frame.createLayout = function( self ) 
		LayoutFrame = Layout(self.Mainframe, self.Objectframe)
		LayoutFrame:createLayout()
	end
	
	frame.Hide = function()
		LayoutFrame:Hide()
	end
	
	frame.Show = function()
		LayoutFrame:Show()
	end
	
	frame.Update = function()
		LayoutFrame:Update()
	end
	
	frame.deleteLayout = function()
		LayoutFrame:deleteLayout()
	end
end																		-- Ende initialize

registerLayout(NameOfLayout)												